#include <iostream>
#include <algorithm>
#include <vector>

bool cmp(const long long& a, const long long& b)
{
    return a < b;
}

/*
long long num_flower_types(long long* a, long long& n, long long& l, long long& r)
{
    long long res_l, res_r;
    long long lindex = 0, rindex = n-1;
    long long mindex;

    lstart:
    //find leftmost element == l
    mindex = (lindex + rindex) / 2;
    if(a[mindex] > l)
    {
        rindex = mindex - 1;
    }
    else if(a[mindex] < l)
    {
        lindex = mindex + 1;
    }
    else //if(a[mindex] == l)
    {
        rindex = mindex;
    }
    if(lindex < rindex)
        goto lstart;

    res_l = lindex;

    lindex = 0; rindex = n-1;

    rstart:
    mindex = (lindex + rindex) / 2;
    if(a[mindex] > r)
    {
        rindex = mindex - 1;
    }
    else if(a[mindex] < r)
    {
        lindex = mindex + 1;
    }
    else //if(a[mindex] == r)
    {
        lindex = mindex;
    }
    if(lindex < rindex)
        goto rstart;

    res_r = rindex;

    return res_r - res_l;
}
*/

long long num_flower_types2(long long* arr, long long n, long long l, long long r)
{
    long long lindex = -1, rindex = -1;
    for(long long i = 0; i < n; i++)
    {
        if(l <= arr[i])
        {
            lindex = i;
            break;
        }
    }

    for(long long i = n - 1; i >= 0; i--)
    {
        if(arr[i] <= r)
        {
            rindex = i;
            break;
        }
    }

    if(lindex == -1 || rindex == -1)
        return -1;

    return rindex - lindex + 1;
}

long long min_combination_k(long long n, long long k)
{
    long long i = 0;
    long long res = 1;
    long long prev_res = 1;

    //find i: nCi >= k
    while(true)
    {
        i++;
        prev_res = res;

        res *= (n - i + 1);
        res /= i;

        if(prev_res >= res)
            return -1;

        if(res >= k)
            return i;
    }
}

int main()
{
    // std::ios_base::sync_with_stdio(false);
    // std::cin.tie(NULL);

    long long n, m;
    std::cin >> n >> m;

    long long a[n];
    for(long long i = 0; i < n; i++)
    {
        std::cin >> a[i];
    }

    std::sort(a, a+n, cmp);

    long long l, r;

    long long k;

    std::vector<long long> output;

    for(long long i = 0; i < m; i++)
    {
        std::cin >> l >> r >> k;

        long long fl_types = num_flower_types2(a, n, l, r);

        long long min_fl = min_combination_k(fl_types, k);

        output.push_back(min_fl);
    }

    for(long long i = 0; i < output.size() - 1; i++)
    {
        std::cout << output[i] << "\n";
    }

    std::cout << output[output.size() - 1] << std::endl;

    return 0;
}
