#include <iostream>
#include <algorithm>

bool cmp(const int& a, const int& b)
{
    return a < b;
}

/*
int num_flower_types(int* a, int& n, int& l, int& r)
{
    int res_l, res_r;
    int lindex = 0, rindex = n-1;
    int mindex;

    lstart:
    //find leftmost element == l
    mindex = (lindex + rindex) / 2;
    if(a[mindex] > l)
    {
        rindex = mindex - 1;
    }
    else if(a[mindex] < l)
    {
        lindex = mindex + 1;
    }
    else //if(a[mindex] == l)
    {
        rindex = mindex;
    }
    if(lindex < rindex)
        goto lstart;

    res_l = lindex;

    lindex = 0; rindex = n-1;

    rstart:
    mindex = (lindex + rindex) / 2;
    if(a[mindex] > r)
    {
        rindex = mindex - 1;
    }
    else if(a[mindex] < r)
    {
        lindex = mindex + 1;
    }
    else //if(a[mindex] == r)
    {
        lindex = mindex;
    }
    if(lindex < rindex)
        goto rstart;

    res_r = rindex;

    return res_r - res_l;
}
*/

int num_flower_types2(int* arr, int n, int l, int r)
{
    int lindex = -1, rindex = -1;
    for(int i = 0; i < n; i++)
    {
        if(l <= arr[i])
        {
            lindex = i;
            break;
        }
    }

    for(int i = n - 1; i >= 0; i--)
    {
        if(arr[i] <= r)
        {
            rindex = i;
            break;
        }
    }

    if(lindex == -1 || rindex == -1)
        return -1;

    return rindex - lindex + 1;
}

int min_combination_k(int n, int k)
{
    int i = 0;
    long long res = 1;
    long long prev_res = 1;

    //find i: nCi >= k
    while(true)
    {
        i++;
        prev_res = res;

        res *= (n - i + 1);
        res /= i;

        if(prev_res >= res)
            return -1;

        if(res >= k)
            return i;
    }
}

int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);

    int n, m;
    std::cin >> n >> m;

    int a[n];
    for(int i = 0; i < n; i++)
    {
        std::cin >> a[i];
    }

    std::sort(a, a+n, cmp);

    int l, r;

    long long k;

    for(int i = 0; i < m; i++)
    {
        std::cin >> l >> r >> k;

        int fl_types = num_flower_types2(a, n, l, r);

        int min_fl = min_combination_k(fl_types, k);

        std::cout << min_fl;
        if(i != m - 1)
            std::cout << "\n";
    }

    std::cout << std::endl;

    return 0;
}
