#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

const int MAX_N = 3000 + 24;
const int MAX_M = 1e5 + 24;

int n, m;
int flowers[MAX_N], L[MAX_M], R[MAX_M];
unsigned long long K[MAX_M];

void fast_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void input(){
    cin >> n >> m;
    for(int i = 0; i < n; ++i){
        cin >> flowers[i];
    }
    for(int i = 0; i < m; ++i){
        cin >> L[i] >> R[i] >> K[i];
    }
}

unsigned long long n_choose_k(int n, int k){
    unsigned long long ans = 1;
    for(int i = n - k + 1; i <= n; ++i){
        ans *= i;
    }
    for(int i = 1; i <= k; ++i){
        ans /= i;
    }
    return ans;
}

void solve(){
    sort(flowers, flowers + n);

    for(int i = 0; i < m; ++i){
        auto l = lower_bound(flowers, flowers + n, L[i]),
             r = upper_bound(flowers, flowers + n, R[i]);
        int p = r - l;
        // if a bouqet uses Q flowers, we can make P choose Q bouqets
        if(p == 0){
            cout << -1 << "\n";
            continue;
        }
        int q;
        bool found = false;
        for(q = 1; q <= p / 2 + 1; ++q){
            if(n_choose_k(p, q) >= K[i]){
                found = true;
                break;
            }
        }
        if(found) cout << q << "\n";
        else cout << "-1\n";
    }

}

int main(){
    //fast_io();
    input();
    solve();
    return 0;
}
/*

@@@@@@@@@@@@ binary search is annoying as usual

        cout << "We need " << K[i] << " bouqets\n";
        int lower = 1, upper = p / 2 + 1;
        while(lower < upper){
            int mid = lower + (upper - lower) / 2;
            unsigned long long combos = n_choose_k(p, mid);
            cout << "By choosing " << mid << " from a total of " << p << " we get " << combos << " amount of distinct bouqets\n";
            if(K[i] < combos){
                upper = mid - 1;
            }else{
                lower = mid + 1;
            }
        }
        cout << upper * K[i] << "\n";
*/
