#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
using namespace std;

const long long MAX_N = 3000 + 24;
const long long MAX_M = 1e5 + 24;

long long n, m;
long long flowers[MAX_N], L[MAX_M], R[MAX_M];
string K[MAX_M];

bool DEBUG = false;

string number_to_long_number(unsigned long long number){
    unsigned long long _number = number;
    string long_number;
    while(number > 0){
        long_number += (number % 10) + '0';
        number /= 10;
    }
    string _long_number;
    for(long long i = long_number.size() - 1; i >= 0; --i){
        _long_number += long_number[i];
    }
    if(DEBUG) cout << "Converted(ull) " << _number << " to(string) " << _long_number << endl;
    return _long_number;
}

string long_number_add_long_number(string A, string B){
    if(A.size() > B.size()) swap(A, B);
    if(A.size() < B.size()){
        A.insert(0, B.size() - A.size(), '0');
    }
    string long_number;
    long long carry = 0;
    for(long long i = A.size() - 1; i >= 0; --i){
        long long res = A[i] - '0' + B[i] - '0' + carry;
        long_number += (res % 10) + '0';
        carry = res / 10;
    }
    while(carry > 0){
        long_number += (carry % 10) + '0';
        carry /= 10;
        //if(carry > 0){ cout << "ALERT!"; }
    }
    string _long_number;
    for(long long i = long_number.size() - 1; i >= 0; --i){
        _long_number += long_number[i];
    }
    if(DEBUG) cout << "(string) " << A << " + " << B << " = " << _long_number << endl;
    return _long_number;
}

string long_number_multiplied_digit(string A, long long B){
    string long_number;
    long long carry = 0;
    for(long long i = A.size() - 1; i >= 0; --i){
        long long res = (A[i] - '0') * B + carry;
        long_number += (res % 10) + '0';
        carry = res / 10;
    }
    while(carry > 0){
        long_number += (carry % 10) + '0';
        carry /= 10;
        //(carry > 0){ cout << "ALERT!"; }
    }
    string _long_number;
    for(long long i = long_number.size() - 1; i >= 0; --i){
        _long_number += long_number[i];
    }
    if(DEBUG) cout << "(string) " << A << " * " << B << " = " << _long_number << endl;
    return _long_number;
}

string long_number_multiplied_long_number(string A, string B){
    string long_number = "0";
    for(long long i = B.size() - 1; i >= 0; i--){
        string intermediate_multiplication = long_number_multiplied_digit(A, B[i] - '0');
        for(long long j = i; j < B.size() - 1; ++j){
            intermediate_multiplication += "0";
        }
        long_number = long_number_add_long_number(long_number, intermediate_multiplication);
    }
    if(DEBUG) cout << "(string) " << A << " * " << B << " = " << long_number << endl;
    return long_number;
}

// A is bigger than B deal with it
string long_number_subtract_long_number(string A, string B){
    string _A = A, _B = B;
    if(B.size() < A.size()){
        B.insert(0, A.size() - B.size(), '0');
    }
    string long_number = "";
    for(long long i = A.size() - 1; i >= 0; --i){
        if(A[i] >= B[i]){
            long_number += A[i] - B[i] + '0';
        }else{ // the gay part
            if(A[i - 1] == '0'){
                A[i - 1] = '9';
                for(long long j = i - 2; j >= 0; j--){
                    if(A[j] != '0'){
                        A[j]--;
                        break;
                    }else{
                        A[j] = '9';
                    }
                }
            }
            else A[i - 1]--;
            long_number += A[i] + 10 - B[i] + '0';
        }
    }
    string _long_number;
    for(long long i = long_number.size() - 1; i >= 0; --i){
        _long_number += long_number[i];
    }
    while(_long_number[0] == '0'){ _long_number.erase(0, 1);}
    if(DEBUG) cout << "(string) " << _A << " - " << _B << " = " << _long_number << endl;
    return _long_number;
}

bool is_greater_or_equal(string A, string B){
    if(A.size() < B.size()) return false;
    if(A.size() > B.size()) return true;
    for(long long i = 0; i < A.size(); ++i){
        if(A[i] > B[i]) return true;
        else if(A[i] < B[i]) return false;
    }
    return A == B;
}

string smart_divide(string A, string B){
    if(DEBUG) cout << A << " / " << B << "...\n";
    string ans = "", looked_part;
    for(long long i = 0; i < A.size(); ++i){
        looked_part += A[i];
        if(is_greater_or_equal(looked_part, B)){
            long long to_add;
            if(DEBUG) cout << looked_part << ": ";
            for(to_add = 1; to_add < 10; ++to_add){
                string intermediate = long_number_multiplied_digit(B, to_add);
                if(to_add == 9) break;
                if(is_greater_or_equal(intermediate, looked_part)){
                    if(intermediate == looked_part) break;
                    to_add --;
                    if(DEBUG) cout << intermediate;
                    break;
                }
            }
            if(DEBUG) cout << " -> " << to_add << endl;
            ans += to_add + '0';
            looked_part = long_number_subtract_long_number(looked_part, long_number_multiplied_digit(B, to_add));
            if(DEBUG) cout << "New looked part " << looked_part << endl;
        }else{
            //cout << looked_part << "\n";
            ans += '0';
        }
    }
    if(DEBUG) cout << endl;
    while(ans[0] == '0'){ans.erase(0, 1);}
    return ans;
}

string n_choose_k(long long n, long long k){
    string ans = number_to_long_number(n - k + 1);
    for(long long i = n - k + 2; i <= n; ++i){
        ans = long_number_multiplied_long_number(ans, number_to_long_number(i));
    }
    string _ans = "1";
    for(long long i = 2; i <= k; ++i){
        _ans = long_number_multiplied_long_number(_ans, number_to_long_number(i));
    }
    //return "1";
    return smart_divide(ans, _ans);
}

void fast_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void input(){
    cin >> n >> m;
    for(long long i = 0; i < n; ++i){
        cin >> flowers[i];
    }
    for(long long i = 0; i < m; ++i){
        cin >> L[i] >> R[i] >> K[i];
    }
}

void solve(){
    sort(flowers, flowers + n);

    for(long long i = 0; i < m; ++i){
        auto l = lower_bound(flowers, flowers + n, L[i]),
             r = upper_bound(flowers, flowers + n, R[i]);
        long long p = r - l;
        // if a bouqet uses Q flowers, we can make P choose Q bouqets
        if(p == 0){
            cout << -1 << "\n";
            continue;
        }
        long long q;
        bool found = false;
        for(q = 1; q <= p / 2 + 1; ++q){
            if(is_greater_or_equal(n_choose_k(p, q), K[i])){ // HERE
                found = true;
                break;
            }
        }
        if(found) cout << q << "\n";
        else cout << "-1\n";
    }

}

int main(){
    //fast_io();
    input();
    solve();
    return 0;
}
/*

@@@@@@@@@@@@ binary search is annoying as usual

        cout << "We need " << K[i] << " bouqets\n";
        long long lower = 1, upper = p / 2 + 1;
        while(lower < upper){
            long long mid = lower + (upper - lower) / 2;
            unsigned long long combos = n_choose_k(p, mid);
            cout << "By choosing " << mid << " from a total of " << p << " we get " << combos << " amount of distinct bouqets\n";
            if(K[i] < combos){
                upper = mid - 1;
            }else{
                lower = mid + 1;
            }
        }
        cout << upper * K[i] << "\n";
*/
