#include<iostream>
#include<vector>
#include<queue>
using namespace std;

const int MAX_N = 2 * 1e5 + 24;
const int INF = 1e9;

int n, k;
vector< pair<int, int> > adj[MAX_N];

void fast_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void input(){
    cin >> n >> k;
    for(int i = 0; i < n - 1; ++i){
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        adj[u].push_back({v, w});
        adj[v].push_back({u, w});
    }
}

long long _find_diameter(int start, bool debug = false){
    if(adj[start].size() != 0) return 0;
    if(debug) cout << "BFS from " << start << ": ";
    vector<bool> visited(n, false);
    queue<int> to_visit;
    vector<long long> distances(n, INF);
    distances[start] = 0;
    to_visit.push(start);
    while(!to_visit.empty()){
        int u = to_visit.front();
        if(debug) cout << u << ", ";
        to_visit.pop();
        if(visited[u]) continue;
        visited[u] = true;
        for(auto V : adj[u]){
            distances[V.first] = min(distances[V.first], distances[u] + V.second);
            if(!visited[V.first]) to_visit.push(V.first);
        }
    }
    if(debug) cout << "distances: ";
    long long ans = 0;
    for(int i = 0; i < n; ++i){
        if(debug) cout << distances[i] << " ";
        ans = max(ans, distances[i]);
    }
    if(debug) cout << "\n";
    return ans;
}

long long find_diameter(){
    long long ans = 0;
    for(int i = 0; i < n; ++i){
        ans = max(ans, _find_diameter(i));
    }
    return ans;
}

void print(){
    for(int i = 0; i < n; ++i){
            cout << i << ": ";
        for(auto edge : adj[i]){
            cout << edge.first << " " << edge.second << ", ";
        }
        cout << endl;
    }
}

int main(){
    //fast_io();
    input();
    if(k == 0) cout << find_diameter();
    else if(k == 1){
        long long ans = find_diameter();
        for(int i = 0; i < n; ++i){
            for(int j = 0; j < adj[i].size(); ++j){
                auto edge = adj[i][j];
                if(edge.first < i) continue;
                int J = 0;
                for(auto EDGE : adj[edge.first]){
                    if(EDGE.first == i){
                        J = i; break;
                    }
                }
                adj[edge.first][J].second--;
                adj[i][j].second--;
                //print();
                ans = min(ans, find_diameter());
                adj[i][j].second++;
                adj[edge.first][J].second++;
            }
        }
        cout << ans;
    }
    return 0;
}
