#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const int MAX_N = 2 * 1e5 + 24;
const int INF = 1e9;

int n, k;
vector< pair<int, int> > adj[MAX_N];

void fast_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void input(){
    cin >> n >> k;
    for(int i = 0; i < n - 1; ++i){
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        adj[u].push_back({v, w});
        adj[v].push_back({u, w});
    }
}

long long _find_diameter(int v, int dist, vector<bool>& visited){
    if(visited[v]) return 0;
    visited[v] = true;
    vector<int> distances;
    bool any = false;
    for(auto edge : adj[v]){
        if(visited[edge.first]) continue;
        any = true;
        distances.push_back(_find_diameter(edge.first, dist + edge.second, visited));
    }
    if(!any){
        cout << dist << " " << v + 1<< ", ";
        return dist;
    }
    if(distances.size() == 1){
        cout << distances[0] << " " << v + 1<< ", ";
        return distances[0];
    }
    sort(distances.begin(), distances.end());
    cout << distances[0] + distances[1] - 2 * dist << " " << v + 1 << ", ";
    return distances[0] + distances[1] - 2 * dist;
}

long long find_diameter(){
    int best, best_sz = 0;
    for(int i = 0; i < n; ++i){
        if(adj[i].size() > best_sz){
            best = i;
            best_sz = adj[i].size();
        }
    }
    vector<bool> visited(n, false);
    return _find_diameter(best, 0, visited);
}

void print(){
    for(int i = 0; i < n; ++i){
            cout << i << ": ";
        for(auto edge : adj[i]){
            cout << edge.first << " " << edge.second << ", ";
        }
        cout << endl;
    }
}

int main(){
    //fast_io();
    input();
    if(k == 0) cout << find_diameter();
    else if(k == 1){
        long long ans = find_diameter();
        for(int i = 0; i < n; ++i){
            for(int j = 0; j < adj[i].size(); ++j){
                auto edge = adj[i][j];
                if(edge.first < i) continue;
                int J = 0;
                for(auto EDGE : adj[edge.first]){
                    if(EDGE.first == i){
                        J = i; break;
                    }
                }
                adj[edge.first][J].second--;
                adj[i][j].second--;
                //print();
                ans = min(ans, find_diameter());
                adj[i][j].second++;
                adj[edge.first][J].second++;
            }
        }
        cout << ans;
    }
    return 0;
}
